# Copyright 2017 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by puppet-codegen and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

require 'google/iam/property/string'
require 'google/object_store'
require 'puppet'

Puppet::Type.newtype(:giam_service_account) do
  @doc = 'A service account in the Identity and Access Management API.'

  autorequire(:gauth_credential) do
    credential = self[:credential]
    raise "#{ref}: required property 'credential' is missing" if credential.nil?
    [credential]
  end

  ensurable

  newparam :credential do
    desc <<-DESC
      A gauth_credential name to be used to authenticate with Google Cloud
      Platform.
    DESC
  end

  newparam(:project) do
    desc 'A Google Cloud Platform project to manage.'
  end

  newparam(:name, namevar: true) do
    # TODO(nelsona): Make this description to match the key of the object.
    desc 'The name of the ServiceAccount.'
  end

  newproperty(:name, parent: Google::Iam::Property::String) do
    desc 'The name of the service account.'
  end

  newproperty(:project_id, parent: Google::Iam::Property::String) do
    desc 'Id of the project that owns the service account. (output only)'
  end

  newproperty(:unique_id, parent: Google::Iam::Property::String) do
    desc 'Unique and stable id of the service account (output only)'
  end

  newproperty(:email, parent: Google::Iam::Property::String) do
    desc 'Email address of the service account. (output only)'
  end

  newproperty(:display_name, parent: Google::Iam::Property::String) do
    desc 'User specified description of service account.'
  end

  newproperty(:oauth2_client_id, parent: Google::Iam::Property::String) do
    desc 'OAuth2 client id for the service account. (output only)'
  end

  # Returns all properties that a provider can export to other resources
  def exports
    provider.exports
  end
end
